//      PKSC#7
//    crypt32.lib
//    Visual Studio 7.0

#include <stdio.h>
#include <stdlib.h> // exit(1)
#include <wtypes.h>
#include <wincrypt.h>

#define MY_TYPE  (PKCS_7_ASN_ENCODING | X509_ASN_ENCODING)

//   
#define CERT_STORE_NAME  L"MY"

//      
#define SIGNER_NAME  L"EVGENY"

void print_signature(DWORD cbSigned, BYTE* pbSigned);
void HandleError(char *s);

int main(int argc, char* argv[])
{
//--------------------------------------------------------------------
// ,   

	BYTE* pbMessage = (BYTE*)"  -  N1";
	DWORD cbMessage = (DWORD)strlen((char*) pbMessage)+1;    

//   

	HCERTSTORE hStoreHandle;   	

	if ( !( hStoreHandle = CertOpenStore(
		CERT_STORE_PROV_SYSTEM,
		0,
		NULL,
		CERT_SYSTEM_STORE_CURRENT_USER,
		//CERT_SYSTEM_STORE_LOCAL_MACHINE,
		CERT_STORE_NAME)))
	{
		HandleError("   MY.");
	}

//     

	PCCERT_CONTEXT pSignerCert; 

	if(pSignerCert = CertFindCertificateInStore(
		hStoreHandle,
		MY_TYPE,
		0,
		CERT_FIND_SUBJECT_STR,
		SIGNER_NAME,
		NULL))
	{
		printf(" .\n");
	}
	else
	{
		HandleError( "  .");
	}


//       
	BYTE  *pbSignedMessageBlob;
	DWORD cbSignedMessageBlob;

//       ..
	CRYPT_SIGN_MESSAGE_PARA  SigParams;

	SigParams.cbSize = sizeof(CRYPT_SIGN_MESSAGE_PARA);
	SigParams.dwMsgEncodingType = MY_TYPE;
	SigParams.pSigningCert = pSignerCert;
	SigParams.HashAlgorithm.pszObjId = szOID_RSA_MD5;
	SigParams.HashAlgorithm.Parameters.cbData = NULL;
	SigParams.cMsgCert = 0;
	SigParams.rgpMsgCert = NULL;
	SigParams.cAuthAttr = 0;
	SigParams.dwInnerContentType = 0;
	SigParams.cMsgCrl = 0;
	SigParams.cUnauthAttr = 0;
	SigParams.dwFlags = 0;
	SigParams.pvHashAuxInfo = NULL;
	SigParams.rgAuthAttr = NULL;


	const BYTE* MessageArray[] = {pbMessage};
	DWORD MessageSizeArray[1];
	MessageSizeArray[0] = cbMessage;

//    

	if(CryptSignMessage(
		&SigParams,         	//   SigParams
		TRUE,                  	//    
		1,	                 	//  
		MessageArray,          	// 
		MessageSizeArray,   	//  
		NULL,                  	//   
		&cbSignedMessageBlob)) 	//  
	{
		printf("  %d.\n",cbSignedMessageBlob);
	}
	else
	{
		HandleError(" CryptSignMessage.");
	}

//    
	if(!(pbSignedMessageBlob = new BYTE[cbSignedMessageBlob]))
	{
		HandleError(".");
	}

//  
	if(CryptSignMessage(
		&SigParams,            //   SigParams
		TRUE,                  //    
		1,                     //  
		MessageArray,          // 
		MessageSizeArray,      //  
		pbSignedMessageBlob,   //   
		&cbSignedMessageBlob)) //  
	{
		printf(": \n");
		print_signature(cbSignedMessageBlob, pbSignedMessageBlob);
	}
	else
	{
		HandleError("");
	}

	if (pbSignedMessageBlob)
		delete pbSignedMessageBlob;

	if(pSignerCert)
		CertFreeCertificateContext(pSignerCert);

	if(CertCloseStore(hStoreHandle, CERT_CLOSE_STORE_CHECK_FLAG))
	{
		printf("\n . \n");
	}
	else
	{
		printf("!");
	}

	return 0;
}

void print_signature(DWORD cbSigned, BYTE* pbSigned)
{
		for(DWORD i=0; i < cbSigned; i++) 
		{
			printf("%2.2x", pbSigned[i]);
			if ((i+1)%32 == 0) printf("\n");
		}
}

void HandleError(char *s)
{
    printf(". \n");
    printf("%s\n",s);
    printf(" N %x.\n", GetLastError());
    printf("   . \n");
    exit(1);
} 
