//    
//    crypt32.lib
//    Visual Studio 7.0

#include <stdio.h>
#include <stdlib.h> // exit(1)

#include <wtypes.h>
#include <wincrypt.h>

#define MY_TYPE  (PKCS_7_ASN_ENCODING | X509_ASN_ENCODING)

//   
#define CERT_STORE_NAME  L"MY"

//      
#define SIGNER_NAME  L"EVGENY"

void print_signature(DWORD cbSigned, BYTE* pbSigned);
void HandleError(char *s);

int main(int argc, char* argv[])
{
//--------------------------------------------------------------------
// ,   

	BYTE* pbMessage = (BYTE*)"  -  N1";
	DWORD cbMessage = (DWORD)strlen((char*) pbMessage)+1;    

//   

	HCERTSTORE hStoreHandle;   	

	if ( !( hStoreHandle = CertOpenStore(
		CERT_STORE_PROV_SYSTEM,
		0,
		NULL,
		CERT_SYSTEM_STORE_CURRENT_USER,
		//CERT_SYSTEM_STORE_LOCAL_MACHINE,
		CERT_STORE_NAME)))
	{
		HandleError("   MY.");
	}

//     

	PCCERT_CONTEXT pSignerCert; 

	if(pSignerCert = CertFindCertificateInStore(
		hStoreHandle,
		MY_TYPE,
		0,
		CERT_FIND_SUBJECT_STR,
		SIGNER_NAME,
		NULL))
	{
		printf(" .\n");
	}
	else
	{
		HandleError( "  .");
	}

//   CryptAcquireCertificatePrivateKey    CSP

	HCRYPTPROV hProv;
	DWORD dwKeySpec; 
	BOOL fCallerFreeProv; 

	if(CryptAcquireCertificatePrivateKey(
		pSignerCert, 
		CRYPT_ACQUIRE_COMPARE_KEY_FLAG, 
		NULL, 
		&hProv, 
		&dwKeySpec, 
		&fCallerFreeProv 
	))
	{
		printf("CryptAcquireCertificatePrivateKey  !\n");
	}
	else
	{
	    HandleError("  CryptAcquireCertificatePrivateKey.\n");
	}

//   hash 
	HCRYPTHASH hHash;

	if(CryptCreateHash(
		hProv, 
		CALG_MD5, 
		0, 
		0, 
		&hHash)) 
	{
		printf("Hash  .\n");
	}
	else
	{
		HandleError(" CryptCreateHash.");
	}

//  hash   
	if(CryptHashData(
		hHash, 
		pbMessage, 
		cbMessage, 
		0)) 
	{
		printf("Hash  .\n");
	}
	else
	{
		HandleError("  CryptHashData.");
	}


//       
	BYTE  *pbSignature;
	DWORD dwSigLen;

	if(CryptSignHash(
		hHash, 
		dwKeySpec,
		NULL, 
		0, 
		NULL, 
		&dwSigLen)) 
	{
		printf("  %d .\n",dwSigLen);
	}
	else
	{
		HandleError(" CryptSignHash.");
	}


	if(pbSignature = new BYTE[dwSigLen]) 
	{
		printf("   .\n");
	}
	else
	{
		HandleError(" .");
	}

	if(CryptSignHash(
		hHash, 
		dwKeySpec,
		NULL, 
		0, 
		pbSignature, 
		&dwSigLen)) 
	{
		printf(":\n");
		print_signature(dwSigLen, pbSignature);
	}
	else
	{
		HandleError(" CryptSignHash.");
	}

	if(pbSignature)
		delete pbSignature;

	if(hHash) 
		CryptDestroyHash(hHash);

	if(hProv) 
		CryptReleaseContext(hProv, 0);

	if(pSignerCert)
		CertFreeCertificateContext(pSignerCert);

	if(CertCloseStore(hStoreHandle,  CERT_CLOSE_STORE_CHECK_FLAG))
	{
		printf("\n . \n");
	}
	else
	{
		printf("!");
	}

	return 0;
}

void print_signature(DWORD cbSigned, BYTE* pbSigned)
{
		for(DWORD i=0; i < cbSigned; i++) 
		{
			printf("%2.2x", pbSigned[i]);
			if ((i+1)%32 == 0) printf("\n");
		}
}
void HandleError(char *s)
{
    printf(". \n");
    printf("%s\n",s);
    printf(" N %x.\n", GetLastError());
    printf("   . \n");
    exit(1);
} 
