//   ,    PKSC#7
//    crypt32.lib
//    Visual Studio 7.0

#include <stdio.h>
#include <stdlib.h> //exit()

#include <wtypes.h>
#include <wincrypt.h>

#define MY_TYPE  (PKCS_7_ASN_ENCODING | X509_ASN_ENCODING)

//   
#define CERT_STORE_NAME  L"MY"

//      
#define SIGNER_NAME  L"EVGENY"

//      CRYPT_VERIFY_MESSAGE_PARA VerifyParams;
PCCERT_CONTEXT WINAPI MyGetSignerCertificateCallback(
  void *pvGetArg,                  // in
  DWORD dwCertEncodingType,        // in
  PCERT_INFO pSignerId,            // in
  HCERTSTORE hMsgCertStore         // in
)
{
  return PCCERT_CONTEXT(pvGetArg);
};

//  hex    
int hex2bin(const char* hexsign, BYTE* pbarray);


void HandleError(char *s);

int main(int argc, char* argv[])
{
//--------------------------------------------------------------------
// ,   

	BYTE* pbMessage = (BYTE*)"  -  N1";
	DWORD cbMessage = (DWORD)strlen((char*) pbMessage)+1;    

//       PKSC#7
	const char* hexsign = 
"3082016e06092a864886f70d010702a082015f3082015b020101310e300c0608"
"2a864886f70d02050500300b06092a864886f70d010701318201373082013302"
"010130818d307f311f301d06092a864886f70d010901161065766740696e746f"
"75726973742e7275310b3009060355040613025255310c300a06035504081303"
"4d4f53310f300d060355040713064d6f73636f7731123010060355040a130949"
"6e746f7572697374310c300a060355040b1303497664310e300c060355040313"
"054341457667020a615eeb5a00000000000a300c06082a864886f70d02050500"
"300d06092a864886f70d010101050004818071df37e9a80308355029533ddb70"
"5c9e5e8bd0b9c5e582d9623f134797a43c49bab00f25368d127f3870366b42dd"
"af71a0d5d475bfb44f9482ec918baf835d9a059e238b12c1945811b78423d8f2"
"11468c6c262099d604e527cefb22bec9a32ccd51624be3bd7684e502d212a6fc"
"1c2e6f132582df7833bcca9a44c8ad877366";

//         

	DWORD cbArray = (DWORD)strlen(hexsign)/2 ;
	BYTE* pbArray = new BYTE[cbArray];

//      
	if (hex2bin(hexsign, pbArray))
	{
		printf(" hex2bin.\n");
		exit(1);
	}

//   

	HCERTSTORE hStoreHandle;   	

	if ( !( hStoreHandle = CertOpenStore(
		CERT_STORE_PROV_SYSTEM,
		0,
		NULL,
		CERT_SYSTEM_STORE_CURRENT_USER,
		//CERT_SYSTEM_STORE_LOCAL_MACHINE,
		CERT_STORE_NAME)))
	{
		HandleError("   MY.");
	}

//     

	PCCERT_CONTEXT pSignerCert; 

	if(pSignerCert = CertFindCertificateInStore(
		hStoreHandle,
		MY_TYPE,
		0,
		CERT_FIND_SUBJECT_STR,
		SIGNER_NAME,
		NULL))
	{
		printf(" .\n");
	}
	else
	{
		HandleError( "  .");
	}

	CRYPT_VERIFY_MESSAGE_PARA VerifyParams;

//    

	VerifyParams.cbSize = sizeof(CRYPT_VERIFY_MESSAGE_PARA);
	VerifyParams.dwMsgAndCertEncodingType = MY_TYPE;
	VerifyParams.hCryptProv = 0;
	VerifyParams.pfnGetSignerCertificate = MyGetSignerCertificateCallback;
	VerifyParams.pvGetArg = (void*)pSignerCert;

	const BYTE* MessageArray[] = {pbMessage};
	DWORD MessageSizeArray[1];
	MessageSizeArray[0] = cbMessage;

//  
	if(CryptVerifyDetachedMessageSignature(
		&VerifyParams,          //    VerifyParams
		0,                      // 
		pbArray,				//   
		cbArray,				//  
		1,                      //  
		MessageArray,           // 
		MessageSizeArray,       //  
		&pSignerCert))			//   
	{
		printf("  !.\n");
	}
	else
	{
		HandleError("  .");
	}
	
//  

	if(pbArray)
		delete pbArray;

	if(pSignerCert)
		CertFreeCertificateContext(pSignerCert);

	if(CertCloseStore(hStoreHandle, CERT_CLOSE_STORE_CHECK_FLAG))
	{
		printf(" . \n");
	}
	else
	{
		printf("!");
	}

	return 0;
}

void HandleError(char *s)
{
    printf(". \n");
    printf("%s\n",s);
    printf(" N %x.\n", GetLastError());
    printf("   . \n");
    exit(1);
} 

int hex2int(char ch) throw(...)
{
	if (ch >= '0' && ch <= '9') return ch - '0';
	if (ch >= 'a' && ch <= 'f') return ch - 'a' + 0xA;
	if (ch >= 'A' && ch <= 'F') return ch - 'A' + 0xA;
	throw 1;		
}

int hex2bin(const char* hexsign, BYTE* pbarray)
{
	try{
		while(*hexsign)
		{
			int aa = hex2int(*hexsign++); 
			int bb = hex2int(*hexsign++);
			*pbarray++ = (BYTE)(aa << 4 | bb); 
		}
	}
	catch(...) {
		return -1;
	}
	return 0;
}
